/// @cond EO_CXX_EO_IMPL

inline ::elm_app_client::_c_constructor elm_app_client::constructor(::efl::eina::string_view package_)
{
   return _c_constructor(package_);
}

inline void elm_app_client::view_all_close() const
{
   eo_do(_concrete_eo_ptr(), ::elm_app_client_view_all_close());
}

inline void elm_app_client::terminate() const
{
   eo_do(_concrete_eo_ptr(), ::elm_app_client_terminate());
}

inline Elm_App_Client_Pending * elm_app_client::view_open(Eina_Value * args_, Elm_App_Client_Open_View_Cb view_open_cb_, const void * data_) const
{
   Elm_App_Client_Pending * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_app_client_view_open(args_, view_open_cb_, data_));
   return _tmp_ret;
}

inline void elm_app_client::view_open_cancel(Elm_App_Client_Pending * pending_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_app_client_view_open_cancel(pending_));
}

inline Eina_Iterator * elm_app_client::views_get() const
{
   Eina_Iterator * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_app_client_views_get());
   return _tmp_ret;
}

inline ::efl::eina::string_view elm_app_client::package_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_app_client_package_get());
   return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm_app_client::view_all_close() const
{
   eo_do(_concrete_eo_ptr(), ::elm_app_client_view_all_close());
}

inline void eo_cxx::elm_app_client::terminate() const
{
   eo_do(_concrete_eo_ptr(), ::elm_app_client_terminate());
}

inline Elm_App_Client_Pending * eo_cxx::elm_app_client::view_open(Eina_Value * args_, Elm_App_Client_Open_View_Cb view_open_cb_, const void * data_) const
{
   Elm_App_Client_Pending * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_app_client_view_open(args_, view_open_cb_, data_));
   return _tmp_ret;
}

inline void eo_cxx::elm_app_client::view_open_cancel(Elm_App_Client_Pending * pending_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_app_client_view_open_cancel(pending_));
}

inline Eina_Iterator * eo_cxx::elm_app_client::views_get() const
{
   Eina_Iterator * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_app_client_views_get());
   return _tmp_ret;
}

inline ::efl::eina::string_view eo_cxx::elm_app_client::package_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_app_client_package_get());
   return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::eo_cxx::elm_app_client::operator ::elm_app_client() const
{
   return *static_cast<::elm_app_client const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm_app_client::operator ::elm_app_client&()
{
   return *static_cast<::elm_app_client*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm_app_client::operator ::elm_app_client const&() const
{
   return *static_cast<::elm_app_client const*>(static_cast<void const*>(this));
}

template <typename T>
void _elm_app_client_view_all_close_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         static_cast<T*>(self->this_)->view_all_close();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _elm_app_client_terminate_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         static_cast<T*>(self->this_)->terminate();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Elm_App_Client_Pending * _elm_app_client_view_open_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Value * args_, Elm_App_Client_Open_View_Cb view_open_cb_, const void * data_)
{
   try
      {
         return static_cast<T*>(self->this_)->view_open(args_, view_open_cb_, data_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_App_Client_Pending * _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void _elm_app_client_view_open_cancel_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_App_Client_Pending * pending_)
{
   try
      {
         static_cast<T*>(self->this_)->view_open_cancel(pending_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Eina_Iterator * _elm_app_client_views_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->views_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Iterator * _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
::efl::eina::string_view _elm_app_client_package_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->package_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         const char * _tmp_ret{};
         return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_app_client >
{
   template <typename T>
   struct type
         : virtual operations< ::eo::base >::template type<T>
   {
      virtual void view_all_close()
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_app_client_view_all_close());
      }

      virtual void terminate()
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_app_client_terminate());
      }

      virtual Elm_App_Client_Pending * view_open(Eina_Value * args_, Elm_App_Client_Open_View_Cb view_open_cb_, const void * data_)
      {
         Elm_App_Client_Pending * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_app_client_view_open(args_, view_open_cb_, data_));
            return _tmp_ret;
      }

      virtual void view_open_cancel(Elm_App_Client_Pending * pending_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_app_client_view_open_cancel(pending_));
      }

      virtual Eina_Iterator * views_get()
      {
         Eina_Iterator * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_app_client_views_get());
            return _tmp_ret;
      }

      virtual ::efl::eina::string_view package_get()
      {
         const char * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_app_client_package_get());
            return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
      }

   };
};


template<>
struct operation_description_class_size< ::elm_app_client >
{
   static constexpr int value = 
#if defined(ELM_APP_CLIENT_PROTECTED) && defined(ELM_APP_CLIENT_BETA)
      6
#elif defined(ELM_APP_CLIENT_PROTECTED)
      6
#elif defined(ELM_APP_CLIENT_BETA)
      6
#else
      6
#endif
      + operation_description_class_size<::eo::base >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm_app_client>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::_elm_app_client_view_all_close_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_app_client_view_all_close);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::_elm_app_client_terminate_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_app_client_terminate);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::_elm_app_client_view_open_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_app_client_view_open);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::_elm_app_client_view_open_cancel_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_app_client_view_open_cancel);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::_elm_app_client_views_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_app_client_views_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::_elm_app_client_package_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_app_client_package_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   initialize_operation_description<T>(::efl::eo::detail::tag<::eo::base>(), &ops[operation_description_class_size< ::elm_app_client >::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm_app_client>)
{
   return (ELM_APP_CLIENT_CLASS);
}

} } }

/// @endcond

